"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractAmqpConsumerMonoSchema = void 0;
const AbstractAmqpBaseConsumer_1 = require("./AbstractAmqpBaseConsumer");
const DEFAULT_BARRIER_RESULT = {
    isPassing: true,
    output: undefined,
};
class AbstractAmqpConsumerMonoSchema extends AbstractAmqpBaseConsumer_1.AbstractAmqpBaseConsumer {
    messageSchema;
    schemaEither;
    constructor(dependencies, options) {
        super(dependencies, options);
        this.messageSchema = options.messageSchema;
        this.schemaEither = {
            result: this.messageSchema,
        };
    }
    resolveSchema(_message) {
        return this.schemaEither;
    }
    /**
     * Override to implement barrier pattern
     */
    preHandlerBarrier(_message) {
        // @ts-ignore
        return Promise.resolve(DEFAULT_BARRIER_RESULT);
    }
}
exports.AbstractAmqpConsumerMonoSchema = AbstractAmqpConsumerMonoSchema;
//# sourceMappingURL=AbstractAmqpConsumerMonoSchema.js.map