import type { Either } from '@lokalise/node-core';
import type { QueueConsumer, MultiSchemaConsumerOptions, BarrierResult } from '@message-queue-toolkit/core';
import { HandlerContainer, MessageSchemaContainer } from '@message-queue-toolkit/core';
import type { NewAMQPConsumerOptions } from './AbstractAmqpBaseConsumer';
import { AbstractAmqpBaseConsumer } from './AbstractAmqpBaseConsumer';
import type { AMQPConsumerDependencies } from './AbstractAmqpService';
export declare abstract class AbstractAmqpConsumerMultiSchema<MessagePayloadType extends object, ExecutionContext> extends AbstractAmqpBaseConsumer<MessagePayloadType, unknown> implements QueueConsumer {
    messageSchemaContainer: MessageSchemaContainer<MessagePayloadType>;
    handlerContainer: HandlerContainer<MessagePayloadType, ExecutionContext>;
    protected readonly executionContext: ExecutionContext;
    constructor(dependencies: AMQPConsumerDependencies, options: NewAMQPConsumerOptions & MultiSchemaConsumerOptions<MessagePayloadType, ExecutionContext>, executionContext: ExecutionContext);
    protected resolveSchema(message: MessagePayloadType): Either<Error, import("zod").ZodType<MessagePayloadType, import("zod").ZodTypeDef, MessagePayloadType>>;
    processMessage(message: MessagePayloadType, messageType: string, barrierOutput: unknown): Promise<Either<'retryLater', 'success'>>;
    protected resolveMessageLog(message: MessagePayloadType, messageType: string): unknown;
    protected preHandlerBarrier(message: MessagePayloadType, messageType: string): Promise<BarrierResult<unknown>>;
}
