import type { Either } from '@lokalise/node-core';
import type { ExistingQueueOptions, MonoSchemaQueueOptions, NewQueueOptions, SyncPublisher } from '@message-queue-toolkit/core';
import type { ZodSchema } from 'zod';
import type { AMQPLocatorType } from './AbstractAmqpBaseConsumer';
import { AbstractAmqpBasePublisher } from './AbstractAmqpBasePublisher';
import type { AMQPDependencies, CreateAMQPQueueOptions } from './AbstractAmqpService';
export declare abstract class AbstractAmqpPublisherMonoSchema<MessagePayloadType extends object> extends AbstractAmqpBasePublisher<MessagePayloadType> implements SyncPublisher<MessagePayloadType> {
    private readonly messageSchema;
    constructor(dependencies: AMQPDependencies, options: (NewQueueOptions<CreateAMQPQueueOptions> | ExistingQueueOptions<AMQPLocatorType>) & MonoSchemaQueueOptions<MessagePayloadType>);
    publish(message: MessagePayloadType): void;
    protected resolveSchema(): Either<Error, ZodSchema<MessagePayloadType>>;
}
