"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractAmqpPublisherMonoSchema = void 0;
const AbstractAmqpBasePublisher_1 = require("./AbstractAmqpBasePublisher");
class AbstractAmqpPublisherMonoSchema extends AbstractAmqpBasePublisher_1.AbstractAmqpBasePublisher {
    messageSchema;
    constructor(dependencies, options) {
        super(dependencies, options);
        this.messageSchema = options.messageSchema;
    }
    publish(message) {
        this.messageSchema.parse(message);
        if (this.logMessages) {
            // @ts-ignore
            const resolvedLogMessage = this.resolveMessageLog(message, message[this.messageTypeField]);
            this.logMessage(resolvedLogMessage);
        }
        this.sendToQueue(message);
    }
    /* c8 ignore start */
    resolveSchema() {
        throw new Error('Not implemented for publisher');
    }
}
exports.AbstractAmqpPublisherMonoSchema = AbstractAmqpPublisherMonoSchema;
//# sourceMappingURL=AbstractAmqpPublisherMonoSchema.js.map