import type { Either } from '@lokalise/node-core';
import type { ExistingQueueOptions, NewQueueOptions, SyncPublisher, MultiSchemaPublisherOptions } from '@message-queue-toolkit/core';
import type { ZodSchema } from 'zod';
import type { AMQPLocatorType } from './AbstractAmqpBaseConsumer';
import { AbstractAmqpBasePublisher } from './AbstractAmqpBasePublisher';
import type { AMQPDependencies, CreateAMQPQueueOptions } from './AbstractAmqpService';
export declare abstract class AbstractAmqpPublisherMultiSchema<MessagePayloadType extends object> extends AbstractAmqpBasePublisher<MessagePayloadType> implements SyncPublisher<MessagePayloadType> {
    private readonly messageSchemaContainer;
    constructor(dependencies: AMQPDependencies, options: (NewQueueOptions<CreateAMQPQueueOptions> | ExistingQueueOptions<AMQPLocatorType>) & MultiSchemaPublisherOptions<MessagePayloadType>);
    publish(message: MessagePayloadType): void;
    protected resolveSchema(message: MessagePayloadType): Either<Error, ZodSchema<MessagePayloadType>>;
}
